#include <stddef.h>
#include <stdlib.h>
#include <conio.h>

void print_array(const char array[], int count) {
    int i;

    for (i = 0; i < count; ++i) {
        unsigned char a = array[i];

        cprintf("%02x ", a);
    }
}

void swap_array(char array[], int count) {
    int i;

    for (i = 0; i < count/2; ++i) {
        int j = count - 1 - i;
        char w = array[i];

        array[i] = array[j];
        array[j] = w;
    }
}

int compare_signed(const void* p0, const void* p1) {
    // Ŕr (char^𕄍tňꍇ́ARpCIvV-jw肷邱)
    const char* d0 = p0;
    const char* d1 = p1;

    return *d0 - *d1;
}

int compare_unsigned(const void* p0, const void* p1) {
    // ȂŔr
    const unsigned char* d0 = p0;
    const unsigned char* d1 = p1;

    return *d0 - *d1;
}

struct Character {
    char name[5];
    int max_hp;
    int hp;
};

void print_characters(int x, int y, const struct Character* characters, int count) {
    int i;

    for (i = 0; i < count; ++i) {
        int row = y;
        int col = x + i * 9;

        gotoxy(col, row  ); cprintf("+-%-5.5s-+", characters[i].name);
        gotoxy(col, row+1); cprintf("|HP :%3d|", characters[i].hp);
        gotoxy(col, row+2); cprintf("|MAX:%3d|", characters[i].max_hp);
        gotoxy(col, row+3); cprintf("+-------+");
    }
}

void recovery_characters(struct Character* characters, int count) {
    int i;

    for (i = 0; i < count; ++i) {
        characters[i].hp = characters[i].max_hp;
    }
}

int main(void)
{
    unsigned int frame = 0;
    int y = 1;

    // ʂ̏
    clrscr();

    // z񑀍
    {
        char array[] = {0x1a,0x1b,0x1c,0x1d,0x1e,0x1f};

        gotoxy(1, y++); cprintf("array=%p", array);
        gotoxy(1, y++); cprintf("sizeof(array)   =%d", sizeof(array));
        gotoxy(1, y++); cprintf("sizeof(array[0])=%d", sizeof(array[0]));

        // z\
        gotoxy(1, y++); print_array(array, sizeof(array)/sizeof(array[0]));

        // z̓ւ
        swap_array(array, sizeof(array)/sizeof(array[0]));

        // z\
        gotoxy(1, y++); print_array(array, sizeof(array)/sizeof(array[0]));
    }

    y++;

    {
        char array[] = {0x51,0xa2,0x43,0xf4,0x25,0x56};

        // z\
        gotoxy(1, y++); print_array(array, sizeof(array)/sizeof(array[0]));

        // z̃\[g(t)
        gotoxy(1, y++); cprintf("qsort(compare_signed);");
        qsort(array, sizeof(array)/sizeof(array[0]), sizeof(array[0]), compare_signed);

        // z\
        gotoxy(1, y++); print_array(array, sizeof(array)/sizeof(array[0]));
    }

    y++;

    {
        char array[] = {0x51,0xa2,0x43,0xf4,0x25,0x56};

        // z\
        gotoxy(1, y++); print_array(array, sizeof(array)/sizeof(array[0]));

        // z̃\[g(Ȃ)
        gotoxy(1, y++); cprintf("qsort(compare_unsigned);");
        qsort(array, sizeof(array)/sizeof(array[0]), sizeof(array[0]), compare_unsigned);

        // z\
        gotoxy(1, y++); print_array(array, sizeof(array)/sizeof(array[0]));
    }

    y++;

    {
        char array[] = {0x03,0x12,0x3a,0x5b,0x6c,0x75};
        char key = 0x75;
        char *p = NULL;

        // z\
        gotoxy(1, y++); print_array(array, sizeof(array)/sizeof(array[0]));

        // ž
        gotoxy(1, y++); cprintf("bsearch(%02x,compare_signed);", key);
        p = bsearch(&key, array, sizeof(array)/sizeof(array[0]), sizeof(array[0]), compare_signed);

        // ʒu\
        gotoxy(1, y++); cprintf("array=%p, p=%p, ofs=%d", array, p, p-array);
    }

    y++;

    {
        // \̂̔z񑀍
        struct Character characters[] = {
            {"TOM", 25},
            {"SAM", 20},
            {"ANNY", 15},
        };

        // \̂̓e\
        print_characters(1, y, characters, sizeof(characters)/sizeof(characters[0]));
        y += 4;

        // lݒ
        gotoxy(1, y++); cprintf("recovery_characters();");
        recovery_characters(characters, sizeof(characters)/sizeof(characters[0]));

        // \̂̓e\
        print_characters(1, y, characters, sizeof(characters)/sizeof(characters[0]));
        y += 4;
    }

    // I点Ȃ߂̖[v
    while(1) {
        gotoxy(0, 0);
        cprintf("%8d", frame++);
    }

    return 0;
}
